package noiseAlgorithms ;

public class RandomGenerator {

  private long initSeed;
  private long current;
  private boolean hsh_b = false;
  private short hsh;
  
  private static final long DEFAULT_SEED = 0;
  private static final long a = 6364136223846793005l;
  private static final long c = 1442695040888963407l;
  private static final long m = Long.MAX_VALUE;  // signed long is used to represent unsigned long (2^63 -1 (Long.MAX_VALUE) is used instead of 2^64 (modulus originally wanted))
  
  public RandomGenerator() {
    this.setSeed(DEFAULT_SEED);
  }
  
  public RandomGenerator(int sd) {
    this.setSeed(sd);
  }
  
  public RandomGenerator(long sd) {
    this.setSeed(sd);
  }
  
  // same as creating a new RandomGenerator with sd as the seed
  public void setSeed(long sd) {
    this.initSeed = sd;
    this.reset();
  }
  
  // same as creating a new RandomGenerator with its initial seed
  public void reset() {
    this.current = this.initSeed;
  }
  
  // this Pseudo Random Number Generator is a Linear Congruential Generator
  // it generates a series of pseudorandom values (long)
  // the generated number is between -m and m-1 (both values included) (or between 0 and 2*m -1 if the long values are considered unsigned)
  private long compute(long X) {
    return a * X + c;  // addition and multiplication are "sign-agnostic", so signed long can be used to represent unsigned long
  }					   // also, no need to use the modulo operation because long are 64-bit and 2*m=2^64
  
  public long next() {
    this.current = this.compute(this.current);
    return this.current;
  }
  
  // return the last long generated by next() (return the seed if next() hasn't been used yet)
  public long current() {
	  return this.current;
  }
  
  private long next(int bits) {
    this.next();
    return this.current(bits);
  }
  
  // return the "bits" most significant bits of the current long value of the LCG
  private long current(int bits) {
	 return this.current >> (64-bits);
  }

  // return a new pseudorandom int between -Integer.MAX_VALUE and Integer.MAX_VALUE (2^31 -1)
  public int nextInt() {
    this.next();
    return this.currentInt();
  }
  
  // return an int between -Integer.MAX_VALUE and Integer.MAX_VALUE (2^31 -1) using the current long value of the LCG
  public int currentInt() {
    return (int) this.current(32);	// take the 32 most significant bits (sign bit included) of the current long value
  }
  
  
  // return a new pseudorandom int between 0 and range
  public int nextInt(int bound) {
    this.next();
    return this.currentInt(bound);
  }
  
  // return an int between 0 and bound (excluded) using the current long value of the LCG
  public int currentInt(int bound) {
	bound++;
	if (bound <= 0)
      throw new IllegalArgumentException("bound must be positive");
	  
    if ((bound & -bound) == bound)  // this condition only happens when bound is a power of 2
      return (int)((bound * next(31)) >> 31);  // if bound is the n-th power of 2, the returned value is the n most significant bits (sign bit not included) of the current long value
    
    double dbl = this.currentDouble();
    return (int) ((dbl<0 ? -dbl : dbl)*(bound));
  }
  
  public int[] nextIntSequence(int length, int bound) {
	int[] seq = new int[length];
	for (int i=0 ; i<length ; i++) {
	  seq[i] = this.nextInt(bound);
	}
	return seq;
  }
  
  
  // return a new pseudorandom short between -Short.MAX_VALUE and Integer.MAX_VALUE (2^15 -1)
  public short nextShort() {
    this.next();
    return this.currentShort();
  }
  
  // return a short between -Short.MAX_VALUE and Short.MAX_VALUE (2^15 -1) using the current long value of the LCG
  public short currentShort() {
    return (short) this.current(16);	// take the 16 most significant bits (sign bit included) of the current long value
  }
  
  // return a new pseudorandom int between 0 and range
  public short nextShort(short bound) {
    this.next();
    return this.currentShort(bound);
  }
  
  // return an short between 0 and bound (excluded) using the current long value of the LCG
  public short currentShort(short bound) {
	bound++;
	if (bound <= 0)
      throw new IllegalArgumentException("bound must be positive");
	  
    if ((bound & -bound) == bound)  // this condition only happens when bound is a power of 2
      return (short)((bound * next(15)) >> 15);  // if bound is the n-th power of 2, the returned value is the n most significant bits (sign bit not included) of the current long value
    
    double dbl = this.currentDouble();
    return (short) ((dbl<0 ? -dbl : dbl)*(bound));
  }
  
  public short[] nextShortSequence(int length, short bound) {
	short[] seq = new short[length];
	for (int i=0 ; i<length ; i++) {
	  seq[i] = this.nextShort(bound);
	}
	return seq;
  }
  
  
  // return a new pseudorandom double between -1.0 and 1.0
  public double nextDouble() {
    this.next();
    return this.currentDouble();
  }

  // return a double between -1.0 and 1.0 using the current long value of the LCG
  public double currentDouble() {
    return this.current/((double)Long.MIN_VALUE);
  }
  
  // return a new pseudorandom float between -1.0 and 1.0
  public float nextFloat() {
    this.next();
    return this.currentFloat();
  }

  // return a float between -1.0 and 1.0 using the current long value of the LCG
  public float currentFloat() {
    return (float) this.currentDouble();
  }

  // the Marsaglia polar method generates two standard normal random variables using two uniformly distributed variables
  private double cache;
  private boolean valueInCache = false;
  public double nextGaussian() {
    if (valueInCache) {
      valueInCache = false;
      return cache;
    }
    else {
      double x, y, r;
      do {
        x = this.nextDouble();
        y = this.nextDouble();
        r = x*x+y*y;
      } while (r==0 || r>=1);
      double sq = StrictMath.sqrt(-2*StrictMath.log(r)/r);  // StrictMath for reproductibility
      cache = x*sq;
      valueInCache = true;
      return y*sq;
    }
  }

  public double nextGaussian(double mean, double std) {
    return mean+std*this.nextGaussian();
  }
  
  
  public static int hash2D(int x, int y, int[] in, int hash) {
    return in[(in[x & hash] + y) & hash];
  }
  
  public static short hash2D(int x, int y, short[] in, int hash) {
	return in[(in[x & hash] + y) & hash];
  }
  
  
  public static int hash3D(int x, int y, int z, int[] in, int hash) {
	return (in[(in[x & hash] + y) & hash] + z) & hash;
  }
  
  public static short hash3D(int x, int y, int z, short[] in, int hash) {
	return (short) ((in[(in[x & hash] + y) & hash] + z) & hash);
  }


  public static int hash4D(int x, int y, int z, int w, int[] in, int hash) {
	return in[(in[(in[(in[x & hash] + y) & hash] + z) & hash] + w) & hash];
  }
  
  public static short hash4D(int x, int y, int z, int w, short[] in, int hash) {
	return in[(in[(in[(in[x & hash] + y) & hash] + z) & hash] + w) & hash];
  }
}

